<?php

namespace Ulmus\Query;

class OrderBy extends Fragment {
    public int $order = 85;

    public array $orderBy = [];
    
    const SQL_TOKEN = "ORDER BY";
    const SQL_COLLATE = "COLLATE";

    public function set(array $order) : self
    {
        $this->orderBy = $order;
        
        return $this;
    }

    public function add(string|\Stringable $field, ? string $direction = null) : self
    {
        $this->validateFieldType($field);

        $this->orderBy[] = [ $field, $direction ];
        
        return $this;
    }

    public function render() : string
    {
        $list = array_map(function($item) {
            list($field, $direction) = $item;
            
            return implode(' ', array_filter([ $field , $direction ?? null ] ));
        }, $this->orderBy);

        return $this->renderSegments([
            static::SQL_TOKEN, implode(", ", $list)
        ]);
    }

}
